local FirstLootEver = FirstLootEver

FirstLootEver:RegisterAchievement(1, "Anything goes", "Obtain any item.", "Interface\\Icons\\Spell_Shaman_ImprovedReincarnation", function() return true end, {}, "General", nil, 2)
FirstLootEver:RegisterAchievement(2, "A starter's collection", "Obtain 25 different items",
	"Interface\\Icons\\Achievement_GuildPerk_MobileBanking",
	function(addon)
		if addon:HasAchievement(1) then
			local c=0
			for id in pairs(addon.savedVar.items) do
				c=c+1
				if c >= 25 then
					break
				end
			end
			return (c >= 25)
		end
	end,
	{
		function(addon)
			local c=0
			for id in pairs(addon.savedVar.items) do
				c=c+1
				if c>=25 then
					break
				end
			end
			return "Obtain 25 different items", 0, (c>=25), c, 25, (UnitName("player")), 1, 0, c.." / 25", "FirstLootEver_2_1", true
		end,
	},
	"General",
	1,
	3
)
FirstLootEver:RegisterAchievement(3, "I'm all outta titles", "Obtain 50 different items.",
	"Interface\\Icons\\Spell_Arcane_FocusedPower",
	function(addon)
		if addon:HasAchievement(2) then
			local c=0
			for id in pairs(addon.savedVar.items) do
				c=c+1
				if c >= 50 then
					break
				end
			end
			return (c >= 50)
		end
	end,
	{
		function(addon)
			local c=0
			for id in pairs(addon.savedVar.items) do
				c=c+1
				if c>=50 then
					break
				end
			end
			return "Obtain 50 different items", 0, (c>=50), c, 50, (UnitName("player")), 1, 0, c.." / 50", "FirstLootEver_3_1", true
		end,
	},
	"General",
	2,
	4
)
FirstLootEver:RegisterAchievement(4, "Three digits", "Obtain 100 different items.",
	"Interface\\Icons\\Achievement_GuildPerk_MobileBanking",
	function(addon)
		if addon:HasAchievement(3) then
			local c=0
			for id in pairs(addon.savedVar.items) do
				c=c+1
				if c >= 100 then
					break
				end
			end
			return (c >= 100)
		end
	end,
	{
		function(addon)
			local c=0
			for id in pairs(addon.savedVar.items) do
				c=c+1
				if c>=100 then
					break
				end
			end
			return "Obtain 100 different items", 0, (c>=100), c, 100, (UnitName("player")), 1, 0, c.." / 100", "FirstLootEver_4_1", true
		end,
	},
	"General",
	3,
	5
)
FirstLootEver:RegisterAchievement(5, "Double up", "Obtain 200 different items.",
	"Interface\\AddOns\\FirstLootEver\\DoubleUp",
	function(addon)
		if addon:HasAchievement(4) then
			local c=0
			for id in pairs(addon.savedVar.items) do
				c=c+1
				if c >= 200 then
					break
				end
			end
			return (c >= 200)
		end
	end,
	{
		function(addon)
			local c=0
			for id in pairs(addon.savedVar.items) do
				c=c+1
				if c >= 200 then
					break
				end
			end
			return "Obtain 200 different items", 0, (c>=200), c, 200, (UnitName("player")), 1, 0, c.." / 200", "FirstLootEver_5_1", true
		end,
	},
	"General",
	4,
	6
)
FirstLootEver:RegisterAchievement(6, "Tonight We Dine In Hell", "Obtain 300 different items.",
	"Interface\\AddOns\\FirstLootEver\\Sparta",
	function(addon)
		if addon:HasAchievement(5) then
			local c=0
			for id in pairs(addon.savedVar.items) do
				c=c+1
				if c >= 300 then
					break
				end
			end
			return (c >= 300)
		end
	end,
	{
		function(addon)
			local c=0
			for id in pairs(addon.savedVar.items) do
				c=c+1
				if c >= 300 then
					break
				end
			end
			return "Obtain 300 different items", 0, (c>=300), c, 300, (UnitName("player")), 1, 0, c.." / 300", "FirstLootEver_6_1", true
		end,
	},
	"General",
	5,
	nil
)

FirstLootEver:RegisterAchievement(20, "Why do they even buy this?", "Obtain any item of poor quality.",
	"Interface\\Icons\\inv_misc_coin_05",
	function(addon, id)
		if (select(3,GetItemInfo(id))) == 0 then
			return true
		end
	end,
	{
	},
	"Poor",
	nil,
	nil
)

FirstLootEver:RegisterAchievement(40, "Pretty Common", "Obtain any item of common quality.",
	"Interface\\Icons\\Inv_Misc_Toy_01",
	function(addon, id)
		if (select(3,GetItemInfo(id))) == 1 then
			return true
		end
	end,
	{
	},
	"Common",
	nil,
	nil
)

FirstLootEver:RegisterAchievement(60, "Of the Boar", "Obtain any item of uncommon quality.",
	"Interface\\Icons\\Spell_Magic_PolymorphPig",
	function(addon, id)
		if (select(3,GetItemInfo(id))) == 2 then
			return true
		end
	end,
	{
	},
	"Uncommon",
	nil,
	nil
)

FirstLootEver:RegisterAchievement(80, "A Rare Occurrence", "Obtain any item of rare quality.",
	"Interface\\Icons\\Achievement_Halloween_Smiley_01",
	function(addon, id)
		if (select(3,GetItemInfo(id))) == 3 then
			return true
		end
	end,
	{
	},
	"Rare",
	nil,
	nil
)

FirstLootEver:RegisterAchievement(100, "Truly Epic", "Obtain any item of epic quality.",
	"Interface\\Icons\\Spell_BurningSoul",
	function(addon, id)
		if (select(3,GetItemInfo(id))) == 4 then
			return true
		end
	end,
	{
	},
	"Epic",
	nil,
	nil
)


FirstLootEver:RegisterAchievement(120, "Orange is the new Purple","Obtain any item of legendary quality.",
	"Interface\\Icons\\Spell_Fire_Elementaldevastation",
	function(addon, id)
		if (select(3,GetItemInfo(id))) == 5 then
			return true
		end
	end,
	{
	},
	"Legendary",
	nil,
	121
)
FirstLootEver:RegisterAchievement(121, "A Dream Come True...", "Obtain one of the legendary quality weapons listed below.",
	"Interface\\Icons\\Achievement_BG_TrueAVShutout",
	function(addon, id)
		if (id == 19019) or (id == 17182) or (id == 32838) or (id == 32837) or (id == 34334) or (id == 46017) or (id == 49623) or (id == 71086) then
			return true
		end
	end,
	{
		function(addon)
			local has = not not addon.savedVar.items[19019]
			return (GetItemInfo(19019)) or "Thunderfury, Blessed Blade of the Windseeker", 0, has, (has and 1 or 0), 1, has and (UnitName("player")), 0, 19019, has and "1" or "0", "FirstLootEver_121_1"
		end,
		function(addon)
			local has = not not addon.savedVar.items[17182]
			return (GetItemInfo(17182)) or "Sulfuras, Hand of Ragnaros", 0, has, (has and 1 or 0), 1, has and (UnitName("player")), 0, 17182, has and "1" or "0", "FirstLootEver_121_2"
		end,
		function(addon)
			local has = not not addon.savedVar.items[32837]
			return (GetItemInfo(32837)).." (Main Hand)" or "Warglaive of Azzinoth (Main Hand)", 0, has, (has and 1 or 0), 1, has and (UnitName("player")), 0, 32837, has and "1" or "0", "FirstLootEver_121_3"
		end,
		function(addon)
			local has = not not addon.savedVar.items[32838]
			return (GetItemInfo(32838)).." (Off Hand)" or "Warglaive of Azzinoth (Off Hand)", 0, has, (has and 1 or 0), 1, has and (UnitName("player")), 0, 32838, has and "1" or "0", "FirstLootEver_121_4"
		end,
		function(addon)
			local has = not not addon.savedVar.items[34334]
			return (GetItemInfo(34334)) or "Thori'dal, the Stars' Fury", 0, has, (has and 1 or 0), 1, has and (UnitName("player")), 0, 34334, has and "1" or "0", "FirstLootEver_121_5"
		end,
		function(addon)
			local has = not not addon.savedVar.items[46017]
			return (GetItemInfo(46017)) or "Val'anyr, Hammer of Ancient Kings", 0, has, (has and 1 or 0), 1, has and (UnitName("player")), 0, 46017, has and "1" or "0", "FirstLootEver_121_6"
		end,
		function(addon)
			local has = not not addon.savedVar.items[49623]
			return (GetItemInfo(49623)) or "Shadowmourne", 0, has, (has and 1 or 0), 1, has and (UnitName("player")), 0, 49623, has and "1" or "0", "FirstLootEver_121_7"
		end,
		function(addon)
			local has = not not addon.savedVar.items[71086]
			return (GetItemInfo(71086)) or "Dragonwrath, Tarecgosa's Rest", 0, has, (has and 1 or 0), 1, has and (UnitName("player")), 0, 71086, has and "1" or "0", "FirstLootEver_121_8"
		end,
	},
	"Legendary",
	120,
	122
)
FirstLootEver:RegisterAchievement(122, "Wait for it", "Obtain all of the legendary quality weapons listed below.",
	"Interface\\Icons\\Spell_Holy_AvengineWrath",
	function(addon)
		if addon.savedVar.items[19019] and addon.savedVar.items[17182] and addon.savedVar.items[32838] and addon.savedVar.items[32837] and addon.savedVar.items[34334] and addon.savedVar.items[46017] and addon.savedVar.items[49623] and addon.savedVar.items[71086] then
			return true
		end
	end,
	{
		function(addon)
			local has = not not addon.savedVar.items[19019]
			return (GetItemInfo(19019)) or "Thunderfury, Blessed Blade of the Windseeker", 0, has, (has and 1 or 0), 1, has and (UnitName("player")), 0, 19019, has and "1" or "0", "FirstLootEver_122_1"
		end,
		function(addon)
			local has = not not addon.savedVar.items[17182]
			return (GetItemInfo(17182)) or "Sulfuras, Hand of Ragnaros", 0, has, (has and 1 or 0), 1, has and (UnitName("player")), 0, 17182, has and "1" or "0", "FirstLootEver_122_2"
		end,
		function(addon)
			local has = not not addon.savedVar.items[32837]
			return (GetItemInfo(32837)).." (Main Hand)" or "Warglaive of Azzinoth (Main Hand)", 0, has, (has and 1 or 0), 1, has and (UnitName("player")), 0, 32837, has and "1" or "0", "FirstLootEver_122_3"
		end,
		function(addon)
			local has = not not addon.savedVar.items[32838]
			return (GetItemInfo(32838)).." (Off Hand)" or "Warglaive of Azzinoth (Off Hand)", 0, has, (has and 1 or 0), 1, has and (UnitName("player")), 0, 32838, has and "1" or "0", "FirstLootEver_122_4"
		end,
		function(addon)
			local has = not not addon.savedVar.items[34334]
			return (GetItemInfo(34334)) or "Thori'dal, the Stars' Fury", 0, has, (has and 1 or 0), 1, has and (UnitName("player")), 0, 34334, has and "1" or "0", "FirstLootEver_122_5"
		end,
		function(addon)
			local has = not not addon.savedVar.items[46017]
			return (GetItemInfo(46017)) or "Val'anyr, Hammer of Ancient Kings", 0, has, (has and 1 or 0), 1, has and (UnitName("player")), 0, 46017, has and "1" or "0", "FirstLootEver_122_6"
		end,
		function(addon)
			local has = not not addon.savedVar.items[49623]
			return (GetItemInfo(49623)) or "Shadowmourne", 0, has, (has and 1 or 0), 1, has and (UnitName("player")), 0, 49623, has and "1" or "0", "FirstLootEver_122_7"
		end,
		function(addon)
			local has = not not addon.savedVar.items[71086]
			return (GetItemInfo(71086)) or "Dragonwrath, Tarecgosa's Rest", 0, has, (has and 1 or 0), 1, has and (UnitName("player")), 0, 71086, has and "1" or "0", "FirstLootEver_122_8"
		end,
	},
	"Legendary",
	121,
	nil
)

FirstLootEver:RegisterAchievement(140, "An Eye for The Eye", "Loot one of the legendary weapons during the Kael'thas Sunstrider encounter in The Eye of Tempest Keep.",
	"Interface\\Icons\\Ability_Hibernation",
	function(addon, id)
		if (id == 30317) or (id == 30316) or (id == 30312) or (id == 30318) or (id == 30313) or (id == 30311) then
			return true
		end
	end,
	{
		function(addon)
			local has = not not addon.savedVar.items[30317]
			return (GetItemInfo(30317)) or "Cosmic Infuser", 0, has, (has and 1 or 0), 1, has and (UnitName("player")), 0, 30317, has and "1" or "0", "FirstLootEver_140_1"
		end,
		function(addon)
			local has = not not addon.savedVar.items[30316]
			return (GetItemInfo(30316)) or "Devastation", 0, has, (has and 1 or 0), 1, has and (UnitName("player")), 0, 30316, has and "1" or "0", "FirstLootEver_140_2"
		end,
		function(addon)
			local has = not not addon.savedVar.items[30312]
			return (GetItemInfo(30312)) or "Infinity Blade", 0, has, (has and 1 or 0), 1, has and (UnitName("player")), 0, 30312, has and "1" or "0", "FirstLootEver_140_3"
		end,
		function(addon)
			local has = not not addon.savedVar.items[30318]
			return (GetItemInfo(30318)) or "Netherstrand Longbow", 0, has, (has and 1 or 0), 1, has and (UnitName("player")), 0, 30318, has and "1" or "0", "FirstLootEver_140_4"
		end,
		function(addon)
			local has = not not addon.savedVar.items[30313]
			return (GetItemInfo(30313)) or "Staff of Disintegration", 0, has, (has and 1 or 0), 1, has and (UnitName("player")), 0, 30313, has and "1" or "0", "FirstLootEver_140_5"
		end,
		function(addon)
			local has = not not addon.savedVar.items[30311]
			return (GetItemInfo(30311)) or "Warp Slicer", 0, has, (has and 1 or 0), 1, has and (UnitName("player")), 0, 30311, has and "1" or "0", "FirstLootEver_140_6"
		end,
	},
	"Legendary",
	nil,
	141
)
FirstLootEver:RegisterAchievement(141, "Eyeing Completion", "Loot every legendary weapon during the Kael'thas Substrider encounter in The Eye of Tempest Keep.",
	"Interface\\Icons\\Ability_Hunter_AspectOfTheViper",
	function(addon, id)
		if addon.savedVar.items[30317] and addon.savedVar.items[30316] and addon.savedVar.items[30312] and addon.savedVar.items[30318] and addon.savedVar.items[30313] and addon.savedVar.items[30311] then
			return true
		end
	end,
	{
		function(addon)
			local has = not not addon.savedVar.items[30317]
			return (GetItemInfo(30317)) or "Cosmic Infuser", 0, has, (has and 1 or 0), 1, has and (UnitName("player")), 0, 30317, has and "1" or "0", "FirstLootEver_140_1"
		end,
		function(addon)
			local has = not not addon.savedVar.items[30316]
			return (GetItemInfo(30316)) or "Devastation", 0, has, (has and 1 or 0), 1, has and (UnitName("player")), 0, 30316, has and "1" or "0", "FirstLootEver_140_2"
		end,
		function(addon)
			local has = not not addon.savedVar.items[30312]
			return (GetItemInfo(30312)) or "Infinity Blade", 0, has, (has and 1 or 0), 1, has and (UnitName("player")), 0, 30312, has and "1" or "0", "FirstLootEver_140_3"
		end,
		function(addon)
			local has = not not addon.savedVar.items[30318]
			return (GetItemInfo(30318)) or "Netherstrand Longbow", 0, has, (has and 1 or 0), 1, has and (UnitName("player")), 0, 30318, has and "1" or "0", "FirstLootEver_140_4"
		end,
		function(addon)
			local has = not not addon.savedVar.items[30313]
			return (GetItemInfo(30313)) or "Staff of Disintegration", 0, has, (has and 1 or 0), 1, has and (UnitName("player")), 0, 30313, has and "1" or "0", "FirstLootEver_140_5"
		end,
		function(addon)
			local has = not not addon.savedVar.items[30311]
			return (GetItemInfo(30311)) or "Warp Slicer", 0, has, (has and 1 or 0), 1, has and (UnitName("player")), 0, 30311, has and "1" or "0", "FirstLootEver_140_6"
		end,
	},
	"Legendary",
	140,
	nil
)
-- metas start at 1k. they need to be registered after all others are done to parse just-completed achievements properly
FirstLootEver:RegisterAchievement(1000, "Let's all be friends together", "Obtain at least one item of every quality.",
	"Interface\\Icons\\Achievement_DoubleRainbow",
	function(addon)
		if addon:HasAchievement(20) and addon:HasAchievement(40) and addon:HasAchievement(60) and addon:HasAchievement(60) and addon:HasAchievement(80) and addon:HasAchievement(100) and addon:HasAchievement(120) then
			return true
		end
	end,
	{
		function(addon)
			local has = addon:HasAchievement(20)
			return "Poor", 8, has, (has and 1 or 0), 1, has and (UnitName("player")), 0, "FirstLootEver_20", has and "1" or "0", "FirstLootEver_1000_1"
		end,
		function(addon)
			local has = addon:HasAchievement(40)
			return "Common", 8, has, (has and 1 or 0), 1, has and (UnitName("player")), 0, "FirstLootEver_40", has and "1" or "0", "FirstLootEver_1000_2"
		end,
		function(addon)
			local has = addon:HasAchievement(60)
			return "Uncommon", 8, has, (has and 1 or 0), 1, has and (UnitName("player")), 0, "FirstLootEver_60", has and "1" or "0", "FirstLootEver_1000_3"
		end,
		function(addon)
			local has = addon:HasAchievement(80)
			return "Rare", 8, has, (has and 1 or 0), 1, has and (UnitName("player")), 0, "FirstLootEver_80", has and "1" or "0", "FirstLootEver_1000_4"
		end,
		function(addon)
			local has = addon:HasAchievement(100)
			return "Epic", 8, has, (has and 1 or 0), 1, has and (UnitName("player")), 0, "FirstLootEver_100", has and "1" or "0", "FirstLootEver_1000_5"
		end,
		function(addon)
			local has = addon:HasAchievement(120)
			return "Legendary", 8, has, (has and 1 or 0), 1, has and (UnitName("player")), 0, "FirstLootEver_120", has and "1" or "0", "FirstLootEver_1000_6"
		end,
	},
	"",
	nil,
	nil
)




FirstLootEver:RegisterAchievement(1339, "Alpha tester", "Be awesome enough to help with development.",
	"Interface\\Icons\\ThumbsUp",
	function()
		return false
	end,
	{
	},
	"",
	nil,
	1338
)
FirstLootEver:RegisterAchievement(1338, "Repository checkout", "Can't wait for new revisions to package, eh?",
	"Interface\\AddOns\\FirstLootEver\\subversion",
	function()
		return false
	end,
	{
	},
	"",
	1339,
	1337
)
		
FirstLootEver:RegisterAchievement(1337, "Who's awesome?", "You're awesome!",
	"Interface\\AddOns\\FirstLootEver\\treeston",
	function()
		return false
	end,
	{
	},
	"",
	1338,
	nil
)


FirstLootEver:RegenerateAchievementCategoryListings()